import computer
from timeit import default_timer

# Ram size of the computer is 1024 and cache size of the computer is 128.
# Also, ram is randomly-generated with ascii of human-readable characters.
# That is, between the ascii value of 33 and 126.
#
# Below, is a computer object which has a secret in its kernel space.
# There's "ram" and "cache" array of integers
# 
# computer object has 3 user-accessible functions:
#     flush(): clears the cache
#     get_and_add(x, y): for example, if ram[x] = 2, ram[y] = 3, and ram[5] = 10,
#                       then return 10
#     get(i): gets the value within ram at ith index
# 
# If you attempt to access the kernel space of the ram using get() or get_and_add(),
# those functions will simply return -1.
# However, these functions will store its values to the cache even if it has
# accessed the kernel space. This is to emulate the flaw of out-of-order execution.
#
# When the data of ram is stored in cache, it is retrieved very fast. Otherwise,
# it'll take at least 1.5 seconds to retrieve the data
#
# You can use the snippet of code below as a timer:
#   start = default_timer()
#       do something
#   duration = default_timer() - start
#
# Also, when you retrieve data from ram, it'll be in integer. To convert to character,
# you can do `chr(int)`
#
# Once the program reads 'secret', it should stop

victim = computer.computer()
